/**
  ******************************************************************************
  * @ļ    stm32f10x_adc.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļ ṩ ADC ̼.
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    17/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "stm32f10x_adc.h"
#include "stm32f10x_rcc.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

/* ADC DISCNUM mask */
#define CR1_DISCNUM_Reset           ((uint32_t)0xFFFF1FFF)

/* ADC DISCEN mask */
#define CR1_DISCEN_Set              ((uint32_t)0x00000800)
#define CR1_DISCEN_Reset            ((uint32_t)0xFFFFF7FF)

/* ADC JAUTO mask */
#define CR1_JAUTO_Set               ((uint32_t)0x00000400)
#define CR1_JAUTO_Reset             ((uint32_t)0xFFFFFBFF)

/* ADC JDISCEN mask */
#define CR1_JDISCEN_Set             ((uint32_t)0x00001000)
#define CR1_JDISCEN_Reset           ((uint32_t)0xFFFFEFFF)

/* ADC AWDCH mask */
#define CR1_AWDCH_Reset             ((uint32_t)0xFFFFFFE0)

/* ADC Analog watchdog enable mode mask */
#define CR1_AWDMode_Reset           ((uint32_t)0xFF3FFDFF)

/* CR1 register Mask */
#define CR1_CLEAR_Mask              ((uint32_t)0xFFF0FEFF)

/* ADC ADON mask */
#define CR2_ADON_Set                ((uint32_t)0x00000001)
#define CR2_ADON_Reset              ((uint32_t)0xFFFFFFFE)

/* ADC DMA mask */
#define CR2_DMA_Set                 ((uint32_t)0x00000100)
#define CR2_DMA_Reset               ((uint32_t)0xFFFFFEFF)

/* ADC RSTCAL mask */
#define CR2_RSTCAL_Set              ((uint32_t)0x00000008)

/* ADC CAL mask */
#define CR2_CAL_Set                 ((uint32_t)0x00000004)

/* ADC SWSTART mask */
#define CR2_SWSTART_Set             ((uint32_t)0x00400000)

/* ADC EXTTRIG mask */
#define CR2_EXTTRIG_Set             ((uint32_t)0x00100000)
#define CR2_EXTTRIG_Reset           ((uint32_t)0xFFEFFFFF)

/* ADC Software start mask */
#define CR2_EXTTRIG_SWSTART_Set     ((uint32_t)0x00500000)
#define CR2_EXTTRIG_SWSTART_Reset   ((uint32_t)0xFFAFFFFF)

/* ADC JEXTSEL mask */
#define CR2_JEXTSEL_Reset           ((uint32_t)0xFFFF8FFF)

/* ADC JEXTTRIG mask */
#define CR2_JEXTTRIG_Set            ((uint32_t)0x00008000)
#define CR2_JEXTTRIG_Reset          ((uint32_t)0xFFFF7FFF)

/* ADC JSWSTART mask */
#define CR2_JSWSTART_Set            ((uint32_t)0x00200000)

/* ADC injected software start mask */
#define CR2_JEXTTRIG_JSWSTART_Set   ((uint32_t)0x00208000)
#define CR2_JEXTTRIG_JSWSTART_Reset ((uint32_t)0xFFDF7FFF)

/* ADC TSPD mask */
#define CR2_TSVREFE_Set             ((uint32_t)0x00800000)
#define CR2_TSVREFE_Reset           ((uint32_t)0xFF7FFFFF)

/* CR2 register Mask */
#define CR2_CLEAR_Mask              ((uint32_t)0xFFF1F7FD)

/* ADC SQx mask */
#define SQR3_SQ_Set                 ((uint32_t)0x0000001F)
#define SQR2_SQ_Set                 ((uint32_t)0x0000001F)
#define SQR1_SQ_Set                 ((uint32_t)0x0000001F)

/* SQR1 register Mask */
#define SQR1_CLEAR_Mask             ((uint32_t)0xFF0FFFFF)

/* ADC JSQx mask */
#define JSQR_JSQ_Set                ((uint32_t)0x0000001F)

/* ADC JL mask */
#define JSQR_JL_Set                 ((uint32_t)0x00300000)
#define JSQR_JL_Reset               ((uint32_t)0xFFCFFFFF)

/* ADC SMPx mask */
#define SMPR1_SMP_Set               ((uint32_t)0x00000007)
#define SMPR2_SMP_Set               ((uint32_t)0x00000007)

/* ADC JDRx registers offset */
#define JDR_Offset                  ((uint8_t)0x28)

/* ADC1 DR register base address */
#define DR_ADDRESS                  ((uint32_t)0x4001244C)

/* ú -------------------------------------------------------------*/
/* ñ -----------------------------------------------------------*/
/* úԭ -------------------------------------------------------*/
/* ú -----------------------------------------------------------*/

/**
  * @   ADCx ȫĴΪȱʡֵ.
  * @  ADCx: x123ѡADCΧģ.
  * @  û
  */
void ADC_DeInit(ADC_TypeDef* ADCx)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  
  if (ADCx == ADC1)
  {
    /* ʹ ADC1 λ״̬ */
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC1, ENABLE);
    /* Ӹλ״̬ͷ ADC1  */
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC1, DISABLE);
  }
  else if (ADCx == ADC2)
  {
    /* ʹ ADC2 λ״̬ */
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC2, ENABLE);
    /* Ӹλ״̬ͷ ADC2 */
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC2, DISABLE);
  }
  else
  {
    if (ADCx == ADC3)
    {
      /* ʹ ADC3 λ״̬ */
      RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC3, ENABLE);
      /* Ӹλ״̬ͷ ADC3 */
      RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC3, DISABLE);
    }
  }
}

/**
  * @   ADC_InitStruct ָĲʼ ADCx ļĴ.
  * @  ADCx: x 1 23ѡADC Χģ.
  * @  ADC_InitStruct: ָṹ ADC_InitTypeDef ָ,ýṹָADCΧģϢ.
  * @  û
  */
void ADC_Init(ADC_TypeDef* ADCx, ADC_InitTypeDef* ADC_InitStruct)
{
  uint32_t tmpreg1 = 0;
  uint8_t tmpreg2 = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_MODE(ADC_InitStruct->ADC_Mode));
  assert_param(IS_FUNCTIONAL_STATE(ADC_InitStruct->ADC_ScanConvMode));
  assert_param(IS_FUNCTIONAL_STATE(ADC_InitStruct->ADC_ContinuousConvMode));
  assert_param(IS_ADC_EXT_TRIG(ADC_InitStruct->ADC_ExternalTrigConv));   
  assert_param(IS_ADC_DATA_ALIGN(ADC_InitStruct->ADC_DataAlign)); 
  assert_param(IS_ADC_REGULAR_LENGTH(ADC_InitStruct->ADC_NbrOfChannel));

  /*---------------------------- ADCx CR1 Configuration -----------------*/
  /* õ ADCx CR1 ֵ */
  tmpreg1 = ADCx->CR1;
  /*  DUALMOD  SCAN λ */
  tmpreg1 &= CR1_CLEAR_Mask;
  /*  ADCx: ˫ģʽɨתģʽ */
  /*  DUALMOD λ  ADC_Mode ֵ */
  /*  SCAN λ ADC_ScanConvMode ֵ */
  tmpreg1 |= (uint32_t)(ADC_InitStruct->ADC_Mode | ((uint32_t)ADC_InitStruct->ADC_ScanConvMode << 8));
  /* д ADCx CR1 */
  ADCx->CR1 = tmpreg1;

  /*---------------------------- ADCx CR2 Configuration -----------------*/
  /* õ ADCx CR2 ֵ */
  tmpreg1 = ADCx->CR2;
  /*  CONT, ALIGN  EXTSEL λ */
  tmpreg1 &= CR2_CLEAR_Mask;
  /*  ADCx: ⴥ¼תģʽ */
  /*  ALIGN λ ADC_DataAlign ֵ */
  /*  EXTSEL λ ADC_ExternalTrigConv ֵ */
  /*  CONT λ ADC_ContinuousConvMode ֵ */
  tmpreg1 |= (uint32_t)(ADC_InitStruct->ADC_DataAlign | ADC_InitStruct->ADC_ExternalTrigConv |
            ((uint32_t)ADC_InitStruct->ADC_ContinuousConvMode << 1));
  /* д ADCx CR2 */
  ADCx->CR2 = tmpreg1;

  /*---------------------------- ADCx SQR1 Configuration -----------------*/
  /* õ ADCx SQR1 ֵ */
  tmpreg1 = ADCx->SQR1;
  /*  L λ */
  tmpreg1 &= SQR1_CLEAR_Mask;
  /*  ADCx: ŵ */
  /*  L λ ADC_NbrOfChannel ֵ */
  tmpreg2 |= (uint8_t) (ADC_InitStruct->ADC_NbrOfChannel - (uint8_t)1);
  tmpreg1 |= (uint32_t)tmpreg2 << 20;
  /* д ADCx SQR1 */
  ADCx->SQR1 = tmpreg1;
}

/**
  * @   ADC_InitStruct еÿһȱʡֵ.
  * @  ADC_InitStruct : ָṹ ADC_InitTypeDef ָ룬ʼ.
  * @  û
  */
void ADC_StructInit(ADC_InitTypeDef* ADC_InitStruct)
{
  /* λ ADC ʼṹ */
  /* ʼ ADC_Mode Ա */
  ADC_InitStruct->ADC_Mode = ADC_Mode_Independent;
  /* ʼ ADC_ScanConvMode Ա */
  ADC_InitStruct->ADC_ScanConvMode = DISABLE;
  /* ʼ ADC_ContinuousConvMode Ա */
  ADC_InitStruct->ADC_ContinuousConvMode = DISABLE;
  /* ʼ ADC_ExternalTrigConv Ա */
  ADC_InitStruct->ADC_ExternalTrigConv = ADC_ExternalTrigConv_T1_CC1;
  /* ʼ ADC_DataAlign Ա */
  ADC_InitStruct->ADC_DataAlign = ADC_DataAlign_Right;
  /* ʼ ADC_NbrOfChannel Ա */
  ADC_InitStruct->ADC_NbrOfChannel = 1;
}

/**
  * @  ʹܻʧָ ADC .
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ADCx 豸״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_Cmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  ADON λʡģʽ»ADC */
    ADCx->CR2 |= CR2_ADON_Set;
  }
  else
  {
    /* ʧָ ADC 豸 */
    ADCx->CR2 &= CR2_ADON_Reset;
  }
}

/**
  * @  ʹܻʧָ ADC DMA .
  * @  ADCx: x123ѡADCΧģ.
  *        ע: ADC2 û DMA .
  * @  NewState: ѡ ADC DMA ת״̬.
  *        : ENABLE  DISABLE.
  * @  û
  */
void ADC_DMACmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_DMA_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹѡ ADC DMA  */
    ADCx->CR2 |= CR2_DMA_Set;
  }
  else
  {
    /* ʧѡ ADC DMA  */
    ADCx->CR2 &= CR2_DMA_Reset;
  }
}

/**
  * @  ʹܻʧָADCж.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_IT: ָ ADC жԴ. 
  *          ʹֵһ߼ֵ:
  *          ADC_IT_EOC:  ж
  *          ADC_IT_AWD:  ģ⿴Źж
  *          ADC_IT_JEOC: עͨж
  * @  NewState: ָ ADC жϵ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_ITConfig(ADC_TypeDef* ADCx, uint16_t ADC_IT, FunctionalState NewState)
{
  uint8_t itmask = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  assert_param(IS_ADC_IT(ADC_IT));
  /* õ ADC IT жϺ */
  itmask = (uint8_t)ADC_IT;
  if (NewState != DISABLE)
  {
    /* ʹѡ ADC ж */
    ADCx->CR1 |= itmask;
  }
  else
  {
    /* ʧָ ADC ж */
    ADCx->CR1 &= (~(uint32_t)itmask);
  }
}

/**
  * @  ָADCУ׼Ĵ.
  * @  ADCx: x123ѡADCΧģ.
  * @  û
  */
void ADC_ResetCalibration(ADC_TypeDef* ADCx)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /* ָADCУ׼Ĵ */  
  ADCx->CR2 |= CR2_RSTCAL_Set;
}

/**
  * @  ȡADCУ׼Ĵ״̬.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADCУ׼Ĵ״̬ (SET  RESET).
  */
FlagStatus ADC_GetResetCalibrationStatus(ADC_TypeDef* ADCx)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /*  RSTCAL λ״̬ */
  if ((ADCx->CR2 & CR2_RSTCAL_Set) != (uint32_t)RESET)
  {
    /*  RSTCAL λ */
    bitstatus = SET;
  }
  else
  {
    /* λ RSTCAL λ */
    bitstatus = RESET;
  }
  /*  RSTCAL λ״̬ */
  return  bitstatus;
}

/**
  * @  ʼָADCУ׼״̬.
  * @  ADCx: x123ѡADCΧģ.
  * @  û
  */
void ADC_StartCalibration(ADC_TypeDef* ADCx)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /* ʹѡ ADC У׼ */  
  ADCx->CR2 |= CR2_CAL_Set;
}

/**
  * @  ȡָADCУ׼״̬.
  * @  ADCx: x123ѡADCΧģ.
  * @  ָADCУ׼״̬ (SET  RESET).
  */
FlagStatus ADC_GetCalibrationStatus(ADC_TypeDef* ADCx)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /*  CAL λ״̬ */
  if ((ADCx->CR2 & CR2_CAL_Set) != (uint32_t)RESET)
  {
    /*  CAL λ: ׼ */
    bitstatus = SET;
  }
  else
  {
    /* λ CAL λ: У׼ */
    bitstatus = RESET;
  }
  /*  CAL λ״̬ */
  return  bitstatus;
}

/**
  * @  ʹܻʧָADCת.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ѡеʼźŵADC״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_SoftwareStartConvCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ѡADCתⲿ¼ѡADCת */
    ADCx->CR2 |= CR2_EXTTRIG_SWSTART_Set;
  }
  else
  {
    /* ֹѡADCתⲿ¼ֹͣѡADCת */
    ADCx->CR2 &= CR2_EXTTRIG_SWSTART_Reset;
  }
}

/**
  * @  ȡADCת״̬.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADCʼת״̬ (SET  RESET).
  */
FlagStatus ADC_GetSoftwareStartConvStatus(ADC_TypeDef* ADCx)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /*  SWSTART λ״̬ */
  if ((ADCx->CR2 & CR2_SWSTART_Set) != (uint32_t)RESET)
  {
    /*  SWSTART λ */
    bitstatus = SET;
  }
  else
  {
    /* λ SWSTART λ */
    bitstatus = RESET;
  }
  /*  SWSTART λ״̬ */
  return  bitstatus;
}

/**
  * @  ADCͨüģʽ.
  * @  ADCx: x123ѡADCΧģ.
  * @  Number: ģʽ³ŵֵֵΧΪ18. 
  * @  û
  */
void ADC_DiscModeChannelCountConfig(ADC_TypeDef* ADCx, uint8_t Number)
{
  uint32_t tmpreg1 = 0;
  uint32_t tmpreg2 = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_REGULAR_DISC_NUMBER(Number));
  /* õȥļĴֵ */
  tmpreg1 = ADCx->CR1;
  /* ȥĲģʽͨ */
  tmpreg1 &= CR1_DISCNUM_Reset;
  /* üģʽͨ */
  tmpreg2 = Number - 1;
  tmpreg1 |= tmpreg2 << 13;
  /* 洢Ĵֵ */
  ADCx->CR1 = tmpreg1;
}

/**
  * @  ʹܻʧָADCͨļģʽ.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ָADCͨļģʽ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_DiscModeCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹָADCͨļģʽ */
    ADCx->CR1 |= CR1_DISCEN_Set;
  }
  else
  {
    /* ʧָADCͨļģʽ */
    ADCx->CR1 &= CR1_DISCEN_Reset;
  }
}

/**
  * @  ָADCĹͨǵת˳Ͳʱ.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_Channel:  ADC ͨ. 
  *          ʹֵһ:
  *          ADC_Channel_0:  ѡADCͨ0  
  *          ADC_Channel_1:  ѡADCͨ1  
  *          ADC_Channel_2:  ѡADCͨ2  
  *          ADC_Channel_3:  ѡADCͨ3  
  *          ADC_Channel_4:  ѡADCͨ4  
  *          ADC_Channel_5:  ѡADCͨ5  
  *          ADC_Channel_6:  ѡADCͨ6  
  *          ADC_Channel_7:  ѡADCͨ7  
  *          ADC_Channel_8:  ѡADCͨ8  
  *          ADC_Channel_9:  ѡADCͨ9  
  *          ADC_Channel_10: ѡADCͨ10  
  *          ADC_Channel_11: ѡADCͨ11  
  *          ADC_Channel_12: ѡADCͨ12  
  *          ADC_Channel_13: ѡADCͨ13  
  *          ADC_Channel_14: ѡADCͨ14  
  *          ADC_Channel_15: ѡADCͨ15  
  *          ADC_Channel_16: ѡADCͨ16  
  *          ADC_Channel_17: ѡADCͨ17  
  * @  Rank: ˳. ȡֵΧ116.
  * @  ADC_SampleTime: ָADCͨĲʱֵ. 
  *          ʹֵһ:
  *          ADC_SampleTime_1Cycles5:   ʱ 1.5   
  *          ADC_SampleTime_7Cycles5:   ʱ 7.5   
  *          ADC_SampleTime_13Cycles5:  ʱ 13.5  
  *          ADC_SampleTime_28Cycles5:  ʱ 28.5  	
  *          ADC_SampleTime_41Cycles5:  ʱ 41.5  	
  *          ADC_SampleTime_55Cycles5:  ʱ 55.5  	
  *          ADC_SampleTime_71Cycles5:  ʱ 71.5  	
  *          ADC_SampleTime_239Cycles5: ʱ 239.5 	
  * @  û
  */
void ADC_RegularChannelConfig(ADC_TypeDef* ADCx, uint8_t ADC_Channel, uint8_t Rank, uint8_t ADC_SampleTime)
{
  uint32_t tmpreg1 = 0, tmpreg2 = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_CHANNEL(ADC_Channel));
  assert_param(IS_ADC_REGULAR_RANK(Rank));
  assert_param(IS_ADC_SAMPLE_TIME(ADC_SampleTime));
  /* ѡ ADC_Channel_10 ... ADC_Channel_17 */
  if (ADC_Channel > ADC_Channel_9)
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SMPR1;
    /* Ҫı־ */
    tmpreg2 = SMPR1_SMP_Set << (3 * (ADC_Channel - 10));
    /* ɵͨʱ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_SampleTime << (3 * (ADC_Channel - 10));
    /* µͨʱ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SMPR1 = tmpreg1;
  }
  else /* ADC_Channel include in ADC_Channel_[0..9] */
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SMPR2;
    /* Ҫı־ */
    tmpreg2 = SMPR2_SMP_Set << (3 * ADC_Channel);
    /* ɵͨʱ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_SampleTime << (3 * ADC_Channel);
    /* µͨʱ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SMPR2 = tmpreg1;
  }
  /* For Rank 1 to 6 */
  if (Rank < 7)
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SQR3;
    /* Ҫı־ */
    tmpreg2 = SQR3_SQ_Set << (5 * (Rank - 1));
    /* ѡɵ SQx λ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_Channel << (5 * (Rank - 1));
    /* ѡµ SQx λ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SQR3 = tmpreg1;
  }
  /* For Rank 7 to 12 */
  else if (Rank < 13)
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SQR2;
    /* Ҫı־ */
    tmpreg2 = SQR2_SQ_Set << (5 * (Rank - 7));
    /* ѡɵ SQx λ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_Channel << (5 * (Rank - 7));
    /* ѡµ SQx λ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SQR2 = tmpreg1;
  }
  /* For Rank 13 to 16 */
  else
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SQR1;
    /* Ҫı־ */
    tmpreg2 = SQR1_SQ_Set << (5 * (Rank - 13));
    /* ѡɵ SQx λ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_Channel << (5 * (Rank - 13));
    /* ѡµ SQx λ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SQR1 = tmpreg1;
  }
}

/**
  * @  ʹܻʧ ADCx ľⲿת.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ѡ ADCx ľⲿתܵ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_ExternalTrigConvCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹ ADCx ľⲿת */
    ADCx->CR2 |= CR2_EXTTRIG_Set;
  }
  else
  {
    /* ʧ ADCx ľⲿת */
    ADCx->CR2 &= CR2_EXTTRIG_Reset;
  }
}

/**
  * @  һ ADCx ת.
  * @  ADCx: x123ѡADCΧģ.
  * @  ת.
  */
uint16_t ADC_GetConversionValue(ADC_TypeDef* ADCx)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /* һ ADCx ת */
  return (uint16_t) ADCx->DR;
}

/**
  * @  һ˫ ADC ģʽµ ADC1  ADC2 ת.
  * @retval ת.
  */
uint32_t ADC_GetDualModeConversionValue(void)
{
  /* ˫תµת */
  return (*(__IO uint32_t *) DR_ADDRESS);
}

/**
  * @  ʹܻʧָ ADC ڹתԶʼעת.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ѡеĽԶעתADC״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_AutoInjectedConvCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹָ ADC ڹתԶʼעת */
    ADCx->CR1 |= CR1_JAUTO_Set;
  }
  else
  {
    /* ʧָ ADC ڹתԶʼעת */
    ADCx->CR1 &= CR1_JAUTO_Reset;
  }
}

/**
  * @  ʹܻʧָ ADC עģʽ
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ADC עͨϼģʽ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_InjectedDiscModeCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʧָ ADC עģʽ */
    ADCx->CR1 |= CR1_JDISCEN_Set;
  }
  else
  {
    /* ʧָ ADC עģʽ */
    ADCx->CR1 &= CR1_JDISCEN_Reset;
  }
}

/**
  * @   ADCx ⲿעת.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_ExternalTrigInjecConv: ʼעתADC. 
  *          ȡֵ֮һ:
  *          ADC_ExternalTrigInjecConv_T1_TRGO: ѡʱ1TRGOΪעתⲿ (for ADC1, ADC2 and ADC3)
  *          ADC_ExternalTrigInjecConv_T1_CC4:  ѡʱ1ĲȽ4Ϊעתⲿ (for ADC1, ADC2 and ADC3)
  *          ADC_ExternalTrigInjecConv_T2_TRGO: ѡʱ2 TRGO Ϊעתⲿ (for ADC1 and ADC2)
  *          ADC_ExternalTrigInjecConv_T2_CC1:  ѡʱ2ĲȽ1Ϊעתⲿ (for ADC1 and ADC2)
  *          ADC_ExternalTrigInjecConv_T3_CC4:  ѡʱ3ĲȽ4Ϊעתⲿ (for ADC1 and ADC2)
  *          ADC_ExternalTrigInjecConv_T4_TRGO: ѡʱ4TRGOΪעתⲿ (for ADC1 and ADC2)
  *          ADC_ExternalTrigInjecConv_Ext_IT15_TIM8_CC4: ⲿж15timer8Ƚ¼Ϊעתⲿ (for ADC1 and ADC2)                       
  *          ADC_ExternalTrigInjecConv_T4_CC3:  ѡʱ4Ƚ3 (for ADC3 only)
  *          ADC_ExternalTrigInjecConv_T8_CC2:  ѡʱ8Ƚ2 (for ADC3 only)                         
  *          ADC_ExternalTrigInjecConv_T8_CC4:  ѡʱ8Ƚ4 (for ADC3 only)
  *          ADC_ExternalTrigInjecConv_T5_TRGO: ѡʱ5¼ (for ADC3 only)                         
  *          ADC_ExternalTrigInjecConv_T5_CC4:  ѡʱ5Ƚ4 (for ADC3 only)                        
  *          ADC_ExternalTrigInjecConv_None:    עתⲿ (for ADC1, ADC2 and ADC3)
  * @  û
  */
void ADC_ExternalTrigInjectedConvConfig(ADC_TypeDef* ADCx, uint32_t ADC_ExternalTrigInjecConv)
{
  uint32_t tmpreg = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_EXT_INJEC_TRIG(ADC_ExternalTrigInjecConv));
  /* õɵļĴֵ */
  tmpreg = ADCx->CR2;
  /* ѡעͨȺⲿ¼ */
  tmpreg &= CR2_JEXTSEL_Reset;
  /* ѡעͨȺⲿ¼ */
  tmpreg |= ADC_ExternalTrigInjecConv;
  /* 洢µļĴֵ */
  ADCx->CR2 = tmpreg;
}

/**
  * @  ʹܻʧ ADCx ľⲿעת.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ָADCⲿעת״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_ExternalTrigInjectedConvCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹ ADCx ľⲿעת */
    ADCx->CR2 |= CR2_JEXTTRIG_Set;
  }
  else
  {
    /* ʧ ADCx ľⲿעת */
    ADCx->CR2 &= CR2_JEXTTRIG_Reset;
  }
}

/**
  * @  ʹܻʧ ADCx עת.
  * @  ADCx: x123ѡADCΧģ.
  * @  NewState: ָ ADC עת״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_SoftwareStartInjectedConvCmd(ADC_TypeDef* ADCx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹ ADCx עתܲעѡ */
    ADCx->CR2 |= CR2_JEXTTRIG_JSWSTART_Set;
  }
  else
  {
    /* ʧ ADCx עתܲעѡ */
    ADCx->CR2 &= CR2_JEXTTRIG_JSWSTART_Reset;
  }
}

/**
  * @  ȡָ ADC עת״̬.
  * @  ADCx: x123ѡADCΧģ.
  * @  ָ ADC עת״̬ (SET  RESET).
  */
FlagStatus ADC_GetSoftwareStartInjectedConvCmdStatus(ADC_TypeDef* ADCx)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  /*  JSWSTART λ״̬ */
  if ((ADCx->CR2 & CR2_JSWSTART_Set) != (uint32_t)RESET)
  {
    /*  JSWSTART λ */
    bitstatus = SET;
  }
  else
  {
    /* λ JSWSTART λ */
    bitstatus = RESET;
  }
  /*  JSWSTART λ״̬ */
  return  bitstatus;
}

/**
  * @  ָ ADC עͨǵת˳Ͳʱ.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_Channel: õADCͨ. 
  *          ȡֵ֮һ:
  *          ADC_Channel_0:  ѡADCͨ0  
  *          ADC_Channel_1:  ѡADCͨ1  
  *          ADC_Channel_2:  ѡADCͨ2  
  *          ADC_Channel_3:  ѡADCͨ3  
  *          ADC_Channel_4:  ѡADCͨ4  
  *          ADC_Channel_5:  ѡADCͨ5  
  *          ADC_Channel_6:  ѡADCͨ6  
  *          ADC_Channel_7:  ѡADCͨ7  
  *          ADC_Channel_8:  ѡADCͨ8  
  *          ADC_Channel_9:  ѡADCͨ9  
  *          ADC_Channel_10: ѡADCͨ10  
  *          ADC_Channel_11: ѡADCͨ11  
  *          ADC_Channel_12: ѡADCͨ12  
  *          ADC_Channel_13: ѡADCͨ13  
  *          ADC_Channel_14: ѡADCͨ14  
  *          ADC_Channel_15: ѡADCͨ15  
  *          ADC_Channel_16: ѡADCͨ16  
  *          ADC_Channel_17: ѡADCͨ17 
  * @  Rank: ˳.ȡֵΧ14.
  * @  ADC_SampleTime: ָADCͨĲʱֵ. 
  *          ʹֵһ:
  *          ADC_SampleTime_1Cycles5:   ʱ 1.5   
  *          ADC_SampleTime_7Cycles5:   ʱ 7.5   
  *          ADC_SampleTime_13Cycles5:  ʱ 13.5  
  *          ADC_SampleTime_28Cycles5:  ʱ 28.5  	
  *          ADC_SampleTime_41Cycles5:  ʱ 41.5  	
  *          ADC_SampleTime_55Cycles5:  ʱ 55.5  	
  *          ADC_SampleTime_71Cycles5:  ʱ 71.5  	
  *          ADC_SampleTime_239Cycles5: ʱ 239.5 		
  * @  û
  */
void ADC_InjectedChannelConfig(ADC_TypeDef* ADCx, uint8_t ADC_Channel, uint8_t Rank, uint8_t ADC_SampleTime)
{
  uint32_t tmpreg1 = 0, tmpreg2 = 0, tmpreg3 = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_CHANNEL(ADC_Channel));
  assert_param(IS_ADC_INJECTED_RANK(Rank));
  assert_param(IS_ADC_SAMPLE_TIME(ADC_SampleTime));
  /* ѡ ADC_Channel_10 ... ADC_Channel_17 */
  if (ADC_Channel > ADC_Channel_9)
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SMPR1;
    /* Ҫı־ */
    tmpreg2 = SMPR1_SMP_Set << (3*(ADC_Channel - 10));
    /* ɵͨʱ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_SampleTime << (3*(ADC_Channel - 10));
    /* µͨʱ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SMPR1 = tmpreg1;
  }
  else /* ADC_Channel include in ADC_Channel_[0..9] */
  {
    /* õɵļĴֵ */
    tmpreg1 = ADCx->SMPR2;
    /* Ҫı־ */
    tmpreg2 = SMPR2_SMP_Set << (3 * ADC_Channel);
    /* ɵͨʱ */
    tmpreg1 &= ~tmpreg2;
    /* Ҫλı־ */
    tmpreg2 = (uint32_t)ADC_SampleTime << (3 * ADC_Channel);
    /* µͨʱ */
    tmpreg1 |= tmpreg2;
    /* 洢µļĴֵ */
    ADCx->SMPR2 = tmpreg1;
  }
  /*  Rank ˳ */
  /* õɵļĴֵ */
  tmpreg1 = ADCx->JSQR;
  /* õ JL ֵ: Number = JL+1 */
  tmpreg3 =  (tmpreg1 & JSQR_JL_Set)>> 20;
  /* Ҫı־: ((Rank-1)+(4-JL-1)) */
  tmpreg2 = JSQR_JSQ_Set << (5 * (uint8_t)((Rank + 3) - (tmpreg3 + 1)));
  /* ѡ JSQx λ */
  tmpreg1 &= ~tmpreg2;
  /* Ҫλı־: ((Rank-1)+(4-JL-1)) */
  tmpreg2 = (uint32_t)ADC_Channel << (5 * (uint8_t)((Rank + 3) - (tmpreg3 + 1)));
  /* λѡоɵ JSQx λ */
  tmpreg1 |= tmpreg2;
  /* 洢µļĴֵ */
  ADCx->JSQR = tmpreg1;
}

/**
  * @  עͨתг
  * @  ADCx: x123ѡADCΧģ.
  * @  Length: תг. 
  *                 1  4 ֵ֮.
  * @  û
  */
void ADC_InjectedSequencerLengthConfig(ADC_TypeDef* ADCx, uint8_t Length)
{
  uint32_t tmpreg1 = 0;
  uint32_t tmpreg2 = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_INJECTED_LENGTH(Length));
  
  /* õɵļĴֵ */
  tmpreg1 = ADCx->JSQR;
  /* עŵĳ JL λ */
  tmpreg1 &= JSQR_JL_Reset;
  /* λעŵĳ JL λ */
  tmpreg2 = Length - 1; 
  tmpreg1 |= tmpreg2 << 20;
  /* 洢µļĴֵ */
  ADCx->JSQR = tmpreg1;
}

/**
  * @  עͨתƫֵ
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_InjectedChannel: ҪƫֵADCעŵ. 
  *          ʹֵһ:
  *          ADC_InjectedChannel_1: ѡעͨ1 
  *          ADC_InjectedChannel_2: ѡעͨ2 
  *          ADC_InjectedChannel_3: ѡעͨ3 
  *          ADC_InjectedChannel_4: ѡעͨ4 
  * @  Offset: ѡеADCעŵƫֵòһ12λֵ.
  * @  û
  */
void ADC_SetInjectedOffset(ADC_TypeDef* ADCx, uint8_t ADC_InjectedChannel, uint16_t Offset)
{
  __IO uint32_t tmp = 0;
  
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_INJECTED_CHANNEL(ADC_InjectedChannel));
  assert_param(IS_ADC_OFFSET(Offset));  
  
  tmp = (uint32_t)ADCx;
  tmp += ADC_InjectedChannel;
  
  /* ѡעͨƫ */
  *(__IO uint32_t *) tmp = (uint32_t)Offset;
}

/**
  * @   ADC ָעͨת
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_InjectedChannel: ָעͨ.
  *          ʹֵһ:
  *          ADC_InjectedChannel_1: ѡעͨ1 
  *          ADC_InjectedChannel_2: ѡעͨ2
  *          ADC_InjectedChannel_3: ѡעͨ3
  *          ADC_InjectedChannel_4: ѡעͨ4
  * @  ת.
  */
uint16_t ADC_GetInjectedConversionValue(ADC_TypeDef* ADCx, uint8_t ADC_InjectedChannel)
{
  __IO uint32_t tmp = 0;
  
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_INJECTED_CHANNEL(ADC_InjectedChannel));

  tmp = (uint32_t)ADCx;
  tmp += ADC_InjectedChannel + JDR_Offset;
  
  /*  ADC ָעͨת */
  return (uint16_t) (*(__IO uint32_t*)  tmp);   
}

/**
  * @  ʹܻʧָ/ȫ壬/עͨϵģ⿴Ź
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_AnalogWatchdog: ADCģ⿴Ź.
  *          ʹֵһ:
  *          ADC_AnalogWatchdog_SingleRegEnable:        ͨģ⿴Ź
  *          ADC_AnalogWatchdog_SingleInjecEnable:      עͨģ⿴Ź
  *          ADC_AnalogWatchdog_SingleRegOrInjecEnable: ͨעͨģ⿴Ź
  *          ADC_AnalogWatchdog_AllRegEnable:           йͨģ⿴Ź
  *          ADC_AnalogWatchdog_AllInjecEnable:         עͨģ⿴Ź
  *          ADC_AnalogWatchdog_AllRegAllInjecEnable:   йͨעͨģ⿴Ź
  *          ADC_AnalogWatchdog_None:                   ģ⿴Ź
  * @  û	  
  */
void ADC_AnalogWatchdogCmd(ADC_TypeDef* ADCx, uint32_t ADC_AnalogWatchdog)
{
  uint32_t tmpreg = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_ANALOG_WATCHDOG(ADC_AnalogWatchdog));
  /* õɵļĴֵ */
  tmpreg = ADCx->CR1;
  /*  AWDEN, AWDENJ  AWDSGL λ */
  tmpreg &= CR1_AWDMode_Reset;
  /* ģ⿴Źģʽ */
  tmpreg |= ADC_AnalogWatchdog;
  /* 洢µļĴֵ */
  ADCx->CR1 = tmpreg;
}

/**
  * @  ģ⿴Źĸ/ֵ.
  * @  ADCx: x123ѡADCΧģ.
  * @  HighThreshold: ģ⿴Źĸֵ.
  *                       һ12λֵ.
  * @  LowThreshold:  ģ⿴Źĵֵ.
  *                       һ12λֵ.
  * @  û
  */
void ADC_AnalogWatchdogThresholdsConfig(ADC_TypeDef* ADCx, uint16_t HighThreshold,
                                        uint16_t LowThreshold)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_THRESHOLD(HighThreshold));
  assert_param(IS_ADC_THRESHOLD(LowThreshold));
  /* ģ⿴Źĸֵ */
  ADCx->HTR = HighThreshold;
  /* ģ⿴Źĵֵ */
  ADCx->LTR = LowThreshold;
}

/**
  * @  ԵADCͨģ⿴Ź
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_Channel: ҪΪģ⿴Źŵ. 
  *          ʹֵһ:
  *          ADC_Channel_0:  ѡADCͨ0  
  *          ADC_Channel_1:  ѡADCͨ1  
  *          ADC_Channel_2:  ѡADCͨ2  
  *          ADC_Channel_3:  ѡADCͨ3  
  *          ADC_Channel_4:  ѡADCͨ4  
  *          ADC_Channel_5:  ѡADCͨ5  
  *          ADC_Channel_6:  ѡADCͨ6  
  *          ADC_Channel_7:  ѡADCͨ7  
  *          ADC_Channel_8:  ѡADCͨ8  
  *          ADC_Channel_9:  ѡADCͨ9  
  *          ADC_Channel_10: ѡADCͨ10  
  *          ADC_Channel_11: ѡADCͨ11  
  *          ADC_Channel_12: ѡADCͨ12  
  *          ADC_Channel_13: ѡADCͨ13  
  *          ADC_Channel_14: ѡADCͨ14  
  *          ADC_Channel_15: ѡADCͨ15  
  *          ADC_Channel_16: ѡADCͨ16  
  *          ADC_Channel_17: ѡADCͨ17 
  * @  û
  */
void ADC_AnalogWatchdogSingleChannelConfig(ADC_TypeDef* ADCx, uint8_t ADC_Channel)
{
  uint32_t tmpreg = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_CHANNEL(ADC_Channel));
  /* õɵļĴֵ */
  tmpreg = ADCx->CR1;
  /* ģ⿴Źͨѡλ */
  tmpreg &= CR1_AWDCH_Reset;
  /* ģ⿴Źͨѡλ */
  tmpreg |= ADC_Channel;
  /* 洢Ĵֵ */
  ADCx->CR1 = tmpreg;
}

/**
  * @  ʹܻʧ¶ȴڲοѹͨ.
  * @  NewState: ¶ȴڲοѹͨ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void ADC_TempSensorVrefintCmd(FunctionalState NewState)
{
  /*  */
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹ¶ȴڲοѹͨ */
    ADC1->CR2 |= CR2_TSVREFE_Set;
  }
  else
  {
    /* ʧ¶ȴڲοѹͨ */
    ADC1->CR2 &= CR2_TSVREFE_Reset;
  }
}

/**
  * @  ƶ ADC ־λ1.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_FLAG: ָҪı־. 
  *          ʹֵһ:
  *          ADC_FLAG_AWD:   ģ⿴Ź־λ
  *          ADC_FLAG_EOC:   ת־λ
  *          ADC_FLAG_JEOC:  עת־λ
  *          ADC_FLAG_JSTRT: עתʼ־λ
  *          ADC_FLAG_STRT:  תʼ־λ
  * @  ADC_FLAG ״̬ (SET  RESET).
  */
FlagStatus ADC_GetFlagStatus(ADC_TypeDef* ADCx, uint8_t ADC_FLAG)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_GET_FLAG(ADC_FLAG));
  /* ָADC״̬λ */
  if ((ADCx->SR & ADC_FLAG) != (uint8_t)RESET)
  {
    /*  ADC_FLAG λ */
    bitstatus = SET;
  }
  else
  {
    /* λ ADC_FLAG λ */
    bitstatus = RESET;
  }
  /*  ADC_FLAG ״̬ */
  return  bitstatus;
}

/**
  * @   ADCx Ĵ־λ.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_FLAG: ı־λ. 
  *          ֵ:
  *          ADC_FLAG_AWD:   ģ⿴Ź־λ
  *          ADC_FLAG_EOC:   ת־λ
  *          ADC_FLAG_JEOC:  עת־λ
  *          ADC_FLAG_JSTRT: עתʼ־λ
  *          ADC_FLAG_STRT:  תʼ־λ
  * @  û
  */
void ADC_ClearFlag(ADC_TypeDef* ADCx, uint8_t ADC_FLAG)
{
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_CLEAR_FLAG(ADC_FLAG));
  /* ָ ADC ־ */
  ADCx->SR = ~(uint32_t)ADC_FLAG;
}

/**
  * @  ָADCжǷ.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_IT: ҪADCжԴ. 
  *          ʹֵһ:
  *          ADC_IT_EOC:  תж
  *          ADC_IT_AWD:  ģ⿴Źж
  *          ADC_IT_JEOC: עתж
  * @  ADC_IT ״̬ (SET  RESET).
  */
ITStatus ADC_GetITStatus(ADC_TypeDef* ADCx, uint16_t ADC_IT)
{
  ITStatus bitstatus = RESET;
  uint32_t itmask = 0, enablestatus = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_GET_IT(ADC_IT));
  /* õ ADC IT жϺ */
  itmask = ADC_IT >> 8;
  /*  ADC_IT λ״̬ */
  enablestatus = (ADCx->CR1 & (uint8_t)ADC_IT) ;
  /* ָ ADC ж */
  if (((ADCx->SR & itmask) != (uint32_t)RESET) && enablestatus)
  {
    /*  ADC_IT */
    bitstatus = SET;
  }
  else
  {
    /* λ ADC_IT */
    bitstatus = RESET;
  }
  /*  ADC_IT ״̬ */
  return  bitstatus;
}

/**
  * @   ADCx жϴλ.
  * @  ADCx: x123ѡADCΧģ.
  * @  ADC_IT:  ADC жϴλ.
  *          ʹֵһ߼ֵ:
  *          ADC_IT_EOC:  תж
  *          ADC_IT_AWD:  ģ⿴Źж
  *          ADC_IT_JEOC: עתж
  * @  û
  */
void ADC_ClearITPendingBit(ADC_TypeDef* ADCx, uint16_t ADC_IT)
{
  uint8_t itmask = 0;
  /*  */
  assert_param(IS_ADC_ALL_PERIPH(ADCx));
  assert_param(IS_ADC_IT(ADC_IT));
  /* õ ADC IT жϺ */
  itmask = (uint8_t)(ADC_IT >> 8);
  /* ѡADCжϹλ */
  ADCx->SR = ~(uint32_t)itmask;
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
