/**
  ******************************************************************************
  * @ļ    stm32f10x_iwdg.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļ ṩ IWDG ̼.
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    09/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "stm32f10x_iwdg.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

/* ---------------------- IWDG registers bit mask ----------------------------*/

/* KR register bit mask */
#define KR_KEY_Reload    ((uint16_t)0xAAAA)
#define KR_KEY_Enable    ((uint16_t)0xCCCC)

/* ú -------------------------------------------------------------*/
/* ñ -----------------------------------------------------------*/
/* úԭ -------------------------------------------------------*/
/* ú -----------------------------------------------------------*/


/**
  * @  ʹܻʧܶԼĴ IWDG_PR  IWDG_RLR д.
  * @  IWDG_WriteAccess:  IWDG_PR  IWDG_RLR Ĵдʵµ״̬.
  *                          ֵ֮һ:
  *                          IWDG_WriteAccess_Enable:  ʹܶԼĴ IWDG_PR  IWDG_RLR д
  *                          IWDG_WriteAccess_Disable: ʧܶԼĴ IWDG_PR  IWDG_RLR д
  * @  û
  */
void IWDG_WriteAccessCmd(uint16_t IWDG_WriteAccess)
{
  /*  */
  assert_param(IS_IWDG_WRITE_ACCESS(IWDG_WriteAccess));
  IWDG->KR = IWDG_WriteAccess;
}

/**
  * @   IWDG ԤƵֵ.
  * @  IWDG_Prescaler: ָ IWDG ԤƵֵ.
  *                        ֵ֮һ:
  *                        IWDG_Prescaler_4:   IWDGԤƵֵΪ 4
  *                        IWDG_Prescaler_8:   IWDGԤƵֵΪ 8
  *                        IWDG_Prescaler_16:  IWDGԤƵֵΪ 16
  *                        IWDG_Prescaler_32:  IWDGԤƵֵΪ 32
  *                        IWDG_Prescaler_64:  IWDGԤƵֵΪ 64
  *                        IWDG_Prescaler_128: IWDGԤƵֵΪ 128
  *                        IWDG_Prescaler_256: IWDGԤƵֵΪ 256
  * @  û
  */
void IWDG_SetPrescaler(uint8_t IWDG_Prescaler)
{
  /*  */
  assert_param(IS_IWDG_PRESCALER(IWDG_Prescaler));
  IWDG->PR = IWDG_Prescaler;
}

/**
  * @   IWDG װֵ.
  * @  Reload: ָ IWDG װֵ.
  *                һ'0''0x0FFF'֮.
  * @  û
  */
void IWDG_SetReload(uint16_t Reload)
{
  /*  */
  assert_param(IS_IWDG_RELOAD(Reload));
  IWDG->RLR = Reload;
}

/**
  * @   IWDG װؼĴֵװ IWDG 
  *        ( IWDG_PR  IWDG_RLR Ĵдʱ).
  * @  û
  * @  û
  */
void IWDG_ReloadCounter(void)
{
  IWDG->KR = KR_KEY_Reload;
}

/**
  * @  ʹ IWDG ( IWDG_PR  IWDG_RLR Ĵдʱ).
  * @  û
  * @  û
  */
void IWDG_Enable(void)
{
  IWDG->KR = KR_KEY_Enable;
}

/**
  * @  ָ IWDG ־λ.
  * @  IWDG_FLAG: Ҫı־.
  *                   ֵ֮һ:
  *                   IWDG_FLAG_PVU: ԤƵֵ
  *                   IWDG_FLAG_RVU: ֵ
  * @  IWDG_FLAG ״̬ (SET  RESET).
  */
FlagStatus IWDG_GetFlagStatus(uint16_t IWDG_FLAG)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_IWDG_FLAG(IWDG_FLAG));
  if ((IWDG->SR & IWDG_FLAG) != (uint32_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  /* ر־״̬ */
  return bitstatus;
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
